/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.npc.MStartGather
 *  fire.pb.scene.SceneClient
 *  fire.pb.scene.movable.GatherNpc
 *  fire.pb.scene.movable.God
 *  fire.pb.scene.movable.Role
 *  fire.pb.util.Parser
 *  mkio.Protocol
 */
package fire.pb.scene.manager;

import fire.msp.npc.MStartGather;
import fire.pb.scene.SceneClient;
import fire.pb.scene.manager.RoleManager;
import fire.pb.scene.manager.SceneNpcManager;
import fire.pb.scene.movable.GatherNpc;
import fire.pb.scene.movable.God;
import fire.pb.scene.movable.Role;
import fire.pb.util.Parser;
import java.util.HashMap;
import java.util.Map;
import mkio.Protocol;

public class GatherManager {
    private static final GatherManager instance = new GatherManager();
    private final Map<Integer, Map<Long, GatherNpc>> gatherMap = new HashMap<Integer, Map<Long, GatherNpc>>();

    public static GatherManager getInstance() {
        return instance;
    }

    public GatherNpc genGathernpc(long npckey, int npcid, String name, int dir) {
        return God.createGatherNpc((long)npckey, (int)npcid, (String)name, null, null, (int)dir);
    }

    public void removeGathernpc(int mapID, long npckey) {
        Map<Long, GatherNpc> mapgathers = this.gatherMap.get(mapID);
        if (mapgathers != null) {
            mapgathers.remove(npckey);
        }
        String trace = Parser.convertfireStackTrace2String((StackTraceElement[])Thread.currentThread().getStackTrace());
        SceneNpcManager.getInstance().removeNpcFromScene(npckey, trace);
    }

    public boolean tryGather(long roleid, long gatherkey) {
        Role role = RoleManager.getInstance().getRoleByID(roleid);
        if (role == null) {
            return false;
        }
        GatherNpc gn = this.getGatherNpc(role.getScene().getMapID(), gatherkey);
        if (gn == null) {
            return false;
        }
        if (gn.canGather(roleid)) {
            MStartGather send = new MStartGather();
            send.gatherid = gn.getNpcID();
            send.gatherkey = gn.getUniqueID();
            send.roleid = roleid;
            SceneClient.pSend((Protocol)send);
            return true;
        }
        return false;
    }

    public void onGatherEnd(long roleid, long gatherkey, int result) {
        Role role = RoleManager.getInstance().getRoleByID(roleid);
        if (role == null) {
            return;
        }
        GatherNpc gn = this.getGatherNpc(role.getScene().getMapID(), gatherkey);
        if (gn == null) {
            return;
        }
        gn.onGatherEnd(roleid, result);
    }

    private GatherNpc getGatherNpc(int mapid, long gatherkey) {
        Map<Long, GatherNpc> mapgathers = this.gatherMap.get(mapid);
        if (mapgathers == null) {
            return null;
        }
        return mapgathers.get(gatherkey);
    }

    public Map<Long, GatherNpc> getGathersByMapID(int mapID) {
        return this.gatherMap.get(mapID);
    }

    public Map<Integer, Map<Long, GatherNpc>> getGatherMap() {
        return this.gatherMap;
    }
}

